package restart;
#|#######################################################
#|#######################################################
sub destroylfichiers {
    my($destroyfiles) = @_ ;
    my(@destroypoints) = () ;
    foreach $file (@$destroyfiles) {
	if (exists $main::lfichiers{$file}) {
	    for ($i=0; $i<=$#{$main::lfichiers{$file}} ; $i++) {
		push(@destroypoints,${$main::lfichiers{$file}}[$i]) ;
	    }
        }
    }
    return(@destroypoints) ;
}
#|#######################################################
sub destroy_key_in_hash {
    local($listetodestroy,$array) = @_ ;
    foreach $cle (@$listetodestroy) {
	delete $$array{"$cle"} if exists $$array{"$cle"} ;
    }
}
#|#######################################################
sub destroy_keynachval_in_hash {
    local($listetodestroy,$array) = @_ ;
    foreach $cle2 (keys %{$array}) {
	foreach $cle1 (@$listetodestroy) {
	    if ("$$array{$cle2}" eq "$cle1") {
		delete $$array{"$cle2"} ;
		last ;
	    }
	}
    }
}
#|#######################################################
sub destroy_key_in_hash_sayval {
    local($listetodestroy,$array) = @_ ;
    my(@sayval) = () ;
    foreach $cle (@$listetodestroy) {
	if (exists $$array{"$cle"}) {
	    if (defined($$array{"$cle"})){
		push(@sayval,keys %{$$array{"$cle"}}) ;
	    }
	    delete $$array{"$cle"} ;
	}
    }
    return(@sayval) ;
}
#|#######################################################
sub destroy_key_in_hash_sayvalue {
    local($listetodestroy,$array) = @_ ;
    my(@sayval) = () ;
    foreach $cle (@$listetodestroy) {
	if (exists $$array{"$cle"}) {
	    if (defined($$array{"$cle"})){
		push(@sayval,values %{$$array{"$cle"}}) ;
	    }
	    delete $$array{"$cle"} ;
	}
    }
    return(@sayval) ;
}
#|#######################################################
sub keep_key_in_hash_sayvalue {
    local($listetodestroy,$array) = @_ ;
    my(@sayval) = () ;
    foreach $cle (@$listetodestroy) {
	if (exists $$array{"$cle"}) {
	    if (defined($$array{"$cle"})){
		push(@sayval,values %{$$array{"$cle"}}) ;
	    }
	}
    }
    return(@sayval) ;
}

#|#######################################################
sub destroy_value_in_hash {
    local($listetodestroy,$array) = @_ ;
    foreach $cle2 (keys %{$array}) {
	foreach $cle1 (@$listetodestroy) {
	    if (exists ${$$array{$cle2}}{$cle1}) {
	        delete ${$$array{$cle2}}{$cle1} ;
            }
	}
    }
}
#|#######################################################
sub destroy_value_input_in_hash {
    local($listetodestroy,$array) = @_ ;
    (%not_inputed) = () ;
    foreach $cle2 (keys %{$array}) {
	foreach $cle1 (@$listetodestroy) {
	    if (exists ${$$array{$cle2}}{$cle1}) {
	        $not_inputed{$cle2} = 1 ;
	        delete ${$$array{$cle2}}{$cle1} ;
            }
	}
    }
}
#|#######################################################
sub destroy_value_include_in_hash {
    local($listetodestroy,$array) = @_ ;
    (%not_included) = () ;
    foreach $cle2 (keys %{$array}) {
	foreach $cle1 (@$listetodestroy) {
	    if (exists ${$$array{$cle2}}{$cle1}) {
	        $not_included{$cle2} = 1 ;
	        delete ${$$array{$cle2}}{$cle1} ;
            }
	}
    }
}
#|#######################################################
sub add_call_analysis_public_procedure {
# the hash table array is set to one on the values of
# File_Of_Rout of the elements of listetoadd.
    local($listetoadd,$array) = @_ ;
    foreach $cle (@$listetoadd) {
	if ($main::File_Of_Rout{$cle}) {
	    $$array{$main::File_Of_Rout{$cle}} = 1 ;
	}
    }
}
#|#######################################################
sub NewCalled {
    my(@destroytotal) = &destroylfichiers(\@destroyfiles) ;
    if ((@sayval)=&restart::keep_key_in_hash_sayvalue(\@destroytotal,\%{main::realcalls})) {
	&Add_To_Refresh_File(\@sayval,\%new_call) ;
	(@destroytotal) = (keys %new_call) ;
	print STDOUT "\tLevel 3 destroytotal=@destroytotal.\n";
	&main::Determine_Types(keys %new_call);
    }
}
#|#######################################################
sub Add_To_Refresh_File {
    local($sayval,$refresh_call) = @_ ;
    foreach $module (@$sayval) {
	local($a,$localFile,$localNum) = &main::GetInfoRoutine($module) ;
	$$refresh_call{$localFile} = 1 if $localFile ;
	if ($debug) {
	    unless ($localFile) {
		print STDERR "Err module=$module\n";
	    }
	}
    }
}
#|#######################################################
sub destroyupentries {
# Aims at destroying wrong entries in Appellees Appelants 
# and realcalls realcalled.
    foreach $point (@destroyfiles,@addfiles) {
	$destpoint{$point} = 1 ;
    }
    (@newdestroydefs) =() ;
    foreach $point (@destroydefs) {
	(@newdest) = (keys %{$main::realcalled{"$point"}}) ;
	foreach $newpoint (@newdest) {
	    local($localProc,$localFile,$localNum) = main::GetInfoRoutine($newpoint) ;
	    unless ($destpoint{$point}) {
		push(@addfiles,$localFile) ;
		push(@newdestroydefs,@{$main::lfichiers{$localFile}});
		$destpoint{$point} = 1 ;
		print INFO "# New File Points is $localFile\n" if $debug;
# newdestroydefs permet de tuer les cls de realcalls et de Appellees avec les valeurs
# de Appelants et de realcalled.
	    }
	}
    }
    foreach $file (@addfiles) {
	$point = "$file:$file:0";
	unless ($destpoint{$point}) {
	    push(@newdestroydefs,$point);
	}
    }
    (@vnewdestroydefs) = () ;
    foreach $point (@newdestroydefs) {
	(@newdest) = (values %{$main::realcalls{"$point"}}) ;
	push(@vnewdestroydefs,@newdest);
    }
    print INFO "#\tArray realcalled and Appelants cleaned from '@vnewdestroydefs'.\n" if ($debug) ;
    &destroy_key_in_hash(\@newdestroydefs,\%{main::realcalls}) ;
    &destroy_key_in_hash(\@newdestroydefs,\%{main::Appellees}) ;
    &destroy_value_in_hash(\@newdestroydefs,\%{main::realcalled}) ;
    &destroy_value_in_hash(\@newdestroydefs,\%{main::Appelants}) ;
    &destroy_key_in_hash(\@newdestroydefs,\%{main::f90includes}) ;
    &destroy_value_in_hash(\@newdestroydefs,\%{main::f90included}) ;
    &destroy_key_in_hash(\@newdestroydefs,\%{main::latexinputs}) ;
    &destroy_value_in_hash(\@newdestroydefs,\%{main::latexinputed}) ;
    &destroy_key_in_hash(\@newdestroydefs,\%{main::available}) ;
    &destroy_key_in_hash(\@newdestroydefs,\%{main::realuses}) ;
    &destroy_value_in_hash(\@newdestroydefs,\%{main::realused}) ;
    print INFO "#\tArray realcalled and Appelants cleaned from '@newdestroydefs'.\n" if ($debug) ;
}
#|#######################################################
sub destroysubentries {
# Status: seems OK for destroying entries and called entries.
    local(@destroyfiles)=@_ ;
    @destroydefs = destroylfichiers(\@destroyfiles) ;
    &destroy_key_in_hash(\@destroyfiles,\%main::lfichiers) ;
    print INFO "#\tArray lfichiers cleaned from '@destroydefs'.\n" if ($debug) ;
# This array tells the files to add to the list of the step 2 analysis.
    %refresh_call = () ;
# The key to success is to use pointers... Larry calls them references.
    foreach $upproc (@destroydefs) {
	local($localProc,$localFile,$localNum) = main::GetInfoRoutine($upproc) ;
	push(@updefprocedures,$localProc) ;
    }
    (@updefprocedures) = &main::Unique(\@updefprocedures) ;
    print INFO "#\tPublic definitions removed = \n#\t  @updefprocedures.\n" if ($debug);
    &destroy_key_in_hash(\@destroydefs,\%main::programmes) ;
    &destroy_key_in_hash(\@destroydefs,\%main::functions) ;
    &destroy_key_in_hash(\@destroydefs,\%main::routines) ;
    &destroy_key_in_hash(\@destroydefs,\%main::module) ;
# The real key to success is a reference at the lowest level possible
# or it could be s symbolic reference as well.
    while ((@sayval)=&destroy_key_in_hash_sayvalue(\@destroydefs,\%{main::sons})) {
	push(@destroydefs,@sayval);
    }
    print INFO "#\tPublic and private definitions to remove at level 1 = \n#\t  @destroydefs.\n" if ($debug) ;
    if ((@sayval)=&destroy_key_in_hash_sayvalue(\@destroydefs,\%{main::realcalls})) {
	(@sayval) = &main::Unique(\@sayval) ;
	&Add_To_Refresh_File(\@sayval,\%refresh_call) ;
	print INFO "#\tCalls dependent are \n#\t @sayval\n" if ($debug);
    } else {
	print INFO "#\tNo subsequent called files to remove.\n" if ($debug);
    }
    if ((@sayval)=&destroy_key_in_hash_sayval(\@destroydefs,\%{main::realuses})) {
	(@sayval) = &main::Unique(\@sayval) ;
	&Add_To_Refresh_File(\@sayval,\%refresh_call) ;
	print INFO "#\tModules dependent are \n#\t @sayval\n" if ($debug);
    } else {
	print INFO "#\tNo subsequent module files to remove.\n" if ($debug);
    }
    (@destroycalled) = (keys %refresh_call);
    print INFO "#\tCalled files level 2 = \n#\t  @destroycalled.\n" if ($debug);
    @destroycall = destroylfichiers(\@destroycalled);
    print INFO "#\tCalled public points level 2 = \n#\t  @destroycall.\n" if ($debug);

    (@sayval)=(@destroycall);
    while ((@sayval)=keep_key_in_hash_sayvalue(\@sayval,\%{main::sons})) {
	push(@destroycall,@sayval);
    }
    print INFO "#\tAll subsequent points level 2 = \n#\t  @destroycall.\n" if ($debug) ;
    (@destroyall)=(@destroydefs,@destroycall) ;
# Destroying level 1 arrays 
    print INFO "#\tDestroying '@destroyall' keys in Appellees and Appelants.\n" if ($debug) ;
    &destroy_key_in_hash(\@destroyall,\%main::Appellees) ;
    &destroy_value_in_hash(\@destroyall,\%main::Appelants) ;

    &destroy_key_in_hash(\@updefprocedures,\%main::L_Declar) ;
    &destroy_key_in_hash(\@updefprocedures,\%main::R_Declar) ;
    &destroy_keynachval_in_hash(\@updefprocedures,\%main::R_Declar) ;
    &destroy_key_in_hash(\@updefprocedures,\%main::label) ;
    &destroy_key_in_hash(\@updefprocedures,\%main::File_Of_Rout) ;
    &destroy_key_in_hash(\@destroyfiles,\%main::File_Of_Rout) ;

    print INFO "#\tDestroying '@destroyall' keys in f90includes.\n" if ($debug) ;
    &destroy_key_in_hash(\@destroydefs,\%{main::father}) ;
    &destroy_key_in_hash(\@destroyall,\%{main::f90includes}) ;
    &destroy_value_include_in_hash(\@destroyall,\%{main::f90included}) ;
    &destroy_key_in_hash(\@destroyall,\%{main::latexinputs}) ;
    &destroy_value_input_in_hash(\@destroyall,\%{main::latexinputed}) ;
    &destroy_key_in_hash(\@destroyall,\%{main::realcalls}) ;
    &destroy_value_in_hash(\@destroyall,\%{main::realcalled}) ;
    &destroy_key_in_hash(\@destroyall,\%{main::available}) ;
    &destroy_key_in_hash(\@destroyall,\%{main::effectcalled}) ;
    &destroy_value_in_hash(\@destroyall,\%{main::realused}) ;
    &destroy_key_in_hash(\@destroyall,\%{main::realuses}) ;
}
#|#######################################################
sub DeleteArrayOnHash {
# Reads the array and if the hash is not an element of the array
# pushes the return list
    my($hash,$array) = @_ ;
    my(@deletefiles) = () ;
    my(%tab) = () ;
    foreach $file (@{$array}) {
	$tab{$file} = 1 ;
    }
    foreach $file (keys %{$hash}) {
	push(@deletefiles,$file) unless $tab{$file} ;
    }
    return(@deletefiles) ;
}
#|#######################################################
sub StageRestartCallInclude {
    local(*INFO) = "main::INFO" ;
    print STDOUT "\tLevel 2 destroyfiles=@destroyfiles.\n" if $main::debug;
    print STDOUT "\tLevel 2 addfiles=@addfiles.\n" if $main::debug;
    print STDOUT "\tLevel 2 destroycalled=@destroycalled.\n" if $main::debug ;
    (@level2files) = (@destroyfiles,@addfiles,@destroycalled) ;
    (@level2files) = &main::Unique(\@level2files);
    print STDOUT "\tLevel 2 on @level2files\n";
    &SuppressLabel(@level2files) ;
    &main::Determine_Types(@level2files);
}
#|#######################################################
sub SuppressLabel {
    my(@files) = @_ ;
    foreach $file (@files) {
	if (exists $main::revlab{$file}) {
	    foreach $lab (@{$main::revlab{$file}}) {
		delete $main::label{$lab} ;
	    }
	    delete $main::revlab{$file} ;
	}
    }
}
#|#######################################################
sub Tex_Analyze {
    my(@restarttex) = () ;
    my(@liste) = () ;
    (@liste)=sort keys %{main::latexinputed} ;
    if ($main::reuse) {
	foreach $file (@liste) {
	    next if (exists $not_inputed{$file}) ;
	    ($a,$file_read,$b)=&main::GetInfoRoutineCasei($file) ;
	    if ($file_read) {
		@mx = stat $file_read ;
		if ($mx[9] > $main::currenttime ) {
		    push(@restarttex,$file) ;
		} 
	    }
	}
	foreach $file (keys %not_inputed) {
	    if (exists $main::latexinputed{$file}) {
		push(@restarttex,$file) ;
	    }
	}
	(@liste) = () ;
	return(@restarttex) ;
    } else {
	return(@liste) ;
    }
}
#|#######################################################
sub Include_Analyze {
    my(@restartinc) = () ;
    my(@liste) = () ;
    (@liste)=sort keys %{main::f90included} ;
    if ($main::reuse) {
	foreach $file (@liste) {
	    next if (exists $not_included{$file}) ;
	    ($a,$file_read,$b)=&main::GetInfoRoutineCasei($file) ;
	    if ($file_read) {
		@mx = stat $file_read ;
		if ($mx[9] > $main::currenttime ) {
		    push(@restartinc,$file) ;
		} 
	    }
	}
	foreach $file (keys %not_included) {
	    if (exists $main::f90included{$file}) {
		push(@restartinc,$file) ;
	    }
	}
	(@liste) = () ;
	return(@restartinc) ;
    } else {
	return(@liste) ;
    }
}
#|#######################################################
sub StageRestartDefinition {
    local(*INFO) = "main::INFO" ;
    if ( $main::currentversion < $main::requireversion) {
	print STDERR "Version from previous run is too old.\n";
	print STDERR "Previous run version is $main::currentversion whereas the required version is at leat $main::requireversion\n";
	print STDERR "Remove $main::DIRE/ftagshtml.info first.\n";
	exit(1) ;
    }
# The list of objects to destroy:
# lfichiers gives the list of definitions of points to suppress,
# f90includes gives the list of includes from the points of destroylist
# that are to be suppressed
    print STDOUT "\tReusing info file ftagshtml.info.\n";
    @addfiles = ( ) ;
    foreach $file (@ARGV) {
	@mx = stat $file ;
	if ($mx[9] > $main::currenttime ) {
	    push(@destroyfiles,$file) ;
	} else {
	    unless (exists $main::lfichiers{"$file"}) {
		push(@addfiles,$file) ;
	    }
	}
    }
    (@deletefiles) = &restart::DeleteArrayOnHash(\%{main::lfichiers},\@ARGV) ;
    (@destroyfiles) = &main::Unique(\@destroyfiles) ;

    if ($debug) {
	open(INFO,">$DIRE/ftagshtml.double") or die "Impossible to create the debug output" ;
	print INFO "#\tRegenerating changed files '@destroyfiles' at all levels.\n";
	print INFO "#\tAdding new files '@addfiles' at all levels.\n";
	print INFO "#\tDeleting old files '@deletefiles' at all levels.\n";
    }
    (@level1files) = (@destroyfiles,@deletefiles) ;
    print STDOUT "\tLevel 0 on @level1files\n" if $debug ;
    &restart::destroysubentries(@destroyfiles,@deletefiles) ;
    (@level1files) = (@destroyfiles,@addfiles);
    print STDOUT "\tLevel 1 on @level1files\n" if $debug;
    &main::Determine_Types(@destroyfiles,@addfiles);
    &restart::destroyupentries(@destroyfiles,@deletefiles) ;
}
#|#######################################################
sub save_hash_in_file {
    local ($array_name, %array) = @_;
    local ($cle, $valeur, $ligne) = ("","","");
    if (%array) {
	$ligne .= "#Array $array_name is defined below\n";
	while (($cle,$valeur) = each %array) {
	    $ligne .= "  \$".$array_name."{\"$cle\"} = \"$valeur\" ;\n";
	}
	$ligne .= "#Array $array_name was defined above\n";
    } else {
	$ligne .= "#Array $array_name is empty\n";
    }
    return ($ligne);
}
#|#######################################################
sub save_array_in_file {
    local ($array_name, @liste) = @_;
    local ($val, $ligne) = ("","");
    if (@liste) {
	$ligne .= "#List $array_name is defined below\n";
	$val = join '", "',@liste ;
	$ligne .= ' @'.$array_name." = (\"$val\") ;\n";
#	$ligne .= "  @".$array_name." =  (";
#	foreach $cle (@liste) {
#	    $ligne .= "\"$cle\", ";
#	}
#	chop($ligne); chop($ligne);
#	$ligne .= ");\n";
	$ligne .= "#List $array_name was defined above\n";
    } else {
	$ligne .= "#List $array_name is empty\n";
    }
    return ($ligne);
}
#|#######################################################
sub save_hash_array_in_file {
    local ($array_name, %array) = @_;
    local ($cle1, $val, $ligne) = ("","","");
    if (%array) {
	$ligne .= "#Array $array_name is defined below\n";
	local (%valeur) = ();
	foreach $cle1 (keys %array) {
	    $val = join '", "',@{$array{$cle1}} ;
	    $ligne .= ' @{$'.$array_name."{\"$cle1\"}} = (\"$val\") ;\n";
        }
	$ligne .= "#Array $array_name was defined above\n";
    } else {
	$ligne .= "#Array $array_name is empty\n";
    }
    return ($ligne);
}
#|#######################################################
sub save_hash_hash_in_file {
    local ($array_name, %array) = @_;
    local ($cle1, $cle2, $val, $ligne) = ("","","","");
    if (%array) {
	$ligne .= "#Array $array_name is defined below\n";
	local (%valeur) = ();
	foreach $cle1 (keys %array) {
#	    $ligne .= "  \$".$array_name."{\"$cle1\"} = () ;\n";
	    foreach $cle2 (keys %{$array{$cle1}}) {
		$val = ${$array{$cle1}}{$cle2} ;
	        $ligne .= '  ${$'.$array_name."{\"$cle1\"}}{\"$cle2\"} = \"".$val."\" ;\n";
	    }
        }
	$ligne .= "#Array $array_name was defined above\n";
    } else {
	$ligne .= "#Array $array_name is empty\n";
    }
    return ($ligne);
}
#|#######################################################
sub save_hash_hash_array_in_file {
    local ($array_name, %array) = @_;
    local ($cle1, $cle2, $ligne) = ("","","","");
    if (%array) {
	$ligne .= "#Array $array_name is defined below\n";
	foreach $cle1 (keys %array) {
	    foreach $cle2 (keys %{$array{$cle1}}) {
		local(@val) = join '", "', @{${$array{$cle1}}{$cle2}} ;
	        $ligne .= "  \@{\${\$".$array_name."{\"$cle1\"}}{\"$cle2\"}} = (\"@val\");\n";
	    }
        }
	$ligne .= "#Array $array_name was defined above\n";
    } else {
	$ligne .= "#Array $array_name is empty\n";
    }
    return ($ligne);
}
#|#######################################################
sub TagsInfo {
    my($INFO)=@_ ;
    *INFO = "main::$INFO" ;
    print INFO "# Stage 1:\n#Information related to the definition points\n";
    print INFO "\$currentversion = $main::currentversion ;\n" ;
    if ($main::currenttime) {
	print INFO "#\$currenttime = ". $main::currenttime . ";\n" ;
    }
    print INFO "\$currenttime = ". time . ";\n" ;
    print INFO save_hash_in_file ("L_Declar", %main::L_Declar);
    print INFO save_hash_in_file ("R_Declar", %main::R_Declar);
    print INFO save_hash_in_file ("File_Of_Rout", %main::File_Of_Rout);
    print INFO save_hash_in_file ("R_Include", %main::R_Include);
    print INFO save_hash_in_file ("father", %main::father);
    print INFO save_hash_hash_in_file ("sons", %main::sons);
    print INFO save_hash_in_file ("programmes", %main::programmes);
    print INFO save_hash_in_file ("functions", %main::functions);
    print INFO save_hash_in_file ("routines", %main::routines);
#    print INFO save_array_in_file ("", @);
    print INFO save_hash_in_file ("module", %main::module);
    print INFO save_hash_array_in_file ("lfichiers", %main::lfichiers);
    print INFO save_hash_hash_array_in_file ("f90includes", %main::f90includes);
    print INFO save_hash_hash_array_in_file ("f90included", %main::f90included);
    print INFO save_hash_hash_array_in_file ("latexinputs", %main::latexinputs);
    print INFO save_hash_hash_array_in_file ("latexinputed", %main::latexinputed);
    print INFO save_hash_in_file ("Include_Unique", %main::Include_Unique);
    print INFO save_hash_in_file ("Input_Unique", %main::Input_Unique);
    print INFO save_hash_in_file ("Input_Alias", %main::Input_Alias);
    print INFO save_hash_in_file ("Include_Alias", %main::Include_Alias);
    print INFO "# End of Stage 1\n";
}
#|#######################################################
sub CallsInfo {
    my($INFO)=@_ ;
    *INFO = "main::$INFO" ;
    print INFO "# Stage 2:\n#Information related to the calling points\n";
    print INFO save_hash_in_file ("label", %main::label);
    print INFO save_hash_array_in_file ("revlab", %main::revlab);
    print INFO save_hash_hash_in_file ("Appellees", %main::Appellees);
    print INFO save_hash_hash_in_file ("Appelants", %main::Appelants);
    print INFO save_hash_hash_in_file ("realcalls", %main::realcalls);
    print INFO save_hash_hash_in_file ("realcalled", %main::realcalled);
    print INFO save_hash_hash_in_file ("rename", %main::rename);
    print INFO save_hash_hash_in_file ("available", %main::available);
    print INFO save_hash_hash_array_in_file ("effectcalled", %main::effectcalled);
    print INFO save_hash_hash_array_in_file ("realuses", %main::realuses);
    print INFO save_hash_hash_array_in_file ("realused", %main::realused);
#    print INFO save_hash_hash_in_file ("", %);
    print INFO "# End of Stage 2\n";
}
#|#######################################################
#|#######################################################
1;


